This is the directory for all non-regression tests, where each subdirectory corresponds to one test, named after the ID of the issue(s) (underscore-separated list if multiple) of the specific bug(s) in the issue management system (e.g. Gitlab, JIRA...) that this test reproduces before fixing. Therefore, this test validates that there have been no regression after fixing the bug. Tests in this directory are run by the class `org.ow2.authzforce.core.test.NonRegression.java` in folder  `src/test/java`. This class expects one subdirectory per test, named `${issueMgtServerId}-${issueId}${suffix}` under directory `src/test/resources/NonRegression`, with the following content (`issueMgtServerId` is either `OW2` if the issue was reported on Authzforce OW2-hosted JIRA site, or `GH` if reported on the GitHub project repository; `issueId` is the issue ID on either site;  you may add a suffix (optional) in the form `.${sub-test_ID}` indicating the ID of the sub-test if the bug requires a sequence of multiple sub-tests to be reproduced; e.g. `OW2-12` would refer to the issue at URL `https://jira.ow2.org/browse/AUTHZFORCE-12`, `GH-34.1` would be the sub-test #1 for the issue at URL `https://github.com/authzforce/core/issues/34`):

- `pdp.xml` (required) : PDP configuration file
- `pdp-ext.xsd` (optional): XSD for loading PDP extensions such as the TestAttributeFinder, required only if such extensions are used in the PDP configuration file 
- `policy.xml` (required): XACML Policy(Set) file
- `request.xml` (optional): XACML Request, absent if the test is only a PDP initialization test (e.g. policy validation)
- `response.xml` (optional): expected XACML Response for the above Request, absent if the test is only PDP initialization test (e.g. policy validation)
- `README.md` (required): title and description of the test, mostly taken from the issue description and comments in the issue management system where the bug was reported.

If the test is a PDP intialization test only, typically a policy syntax validation, we expected an IllegalArgumentException as a result of the test.

If you implement or use a new PDP extension for testing, make sure there have a matching 'system' entry for the resolving the extension XSD location in the XML catalog file `src/test/resources/catalog.xml`, like the one for the TestAttributeFinder XSD.